/* Copyright (C) David Wolfe, 1990.  All rights reserved. */
/* Includes mostly code written by David Moews */

%{
#include <stdlib.h>
#include <ctype.h>
/*  GNU: IF NOT USING GNU, REMOVE THE FOLLOWING #include's */
#include "externs.h"
#include "rational.h"
#include "list.h"
#include "gameops.h"
#include "output.h"
#include "bitmatrx.h"
#include "domino.h"
#include "konane.h"
#include "toads.h"
#include "subtraction.h"
#include "grammar.h"

#define YY_INPUT(buf,result,max_size) \
    { \
	int i; \
	for(i = 0; i < max_size && *parser_input != '\0'; i++) { \
	    buf[i] = *parser_input++; \
	} \
	result = i ? i : YY_NULL; \
    }
%}

%%
play						{return PLAY;}
stat						{return STAT;}
freeze						{return FREEZE;}
chill[\n]					{printf ("%s", chill_string); return ENDOFSTRING;}
map[\n]						{printf ("%s", map_string);  return ENDOFSTRING;}
chill[^\n]*[\n]					{strcpy (chill_string, yytext+5); return ENDOFSTRING;}
warm[^\n]*[\n]					{strcpy (warm_string, yytext+5); return ENDOFSTRING;}
map[^\n]*[\n]					{strcpy (map_string, yytext+4); return ENDOFSTRING;}
on						{return ON;}
off						{return OFF;}
mean						{return MEAN;}
temperature					{return TEMPERATURE;}
temp						{return TEMPERATURE;}
aw						{return AW;}
integers					{return INTEGERS;}
numbers						{return NUMBERS;}
stars						{return STARS;}
ups						{return UPS;}
zeros						{return ZEROS;}
tinys						{return TINYS;}
tinies						{return TINYS;}
ons						{return ONS;}
variables					{return VARS;}
expand						{return EXPAND;}
length						{return LENGTH;}
all						{return ALL;}
limit						{return LIMIT;}
impartial					{return IMPARTIAL;}
prompt						{return PROMPT;}
evaluate					{return EVALUATE;}
eval						{return EVALUATE;}
echo						{return ECHO_;}
reset						{return RESET;}
clean						{return CLEAN;}
tex						{return TEX;}
no						{return NO;}
help[ \t]*[a-zA-Z]*				{char *s;
						 for (s = yytext+4; *s == ' ' || *s == '\t'; s++);
						 strcpy (help_file, s);
						 for (s = help_file; *s != '\0'; s++)
							 if (islower (*s)) *s = toupper (*s);
						 return HELP;
						}
domineering					{return DOMINO;}
domineer					{return DOMINO;}
domino						{return DOMINO;}
dom						{return DOMINO;}
konane						{return KONANE;}
kon						{return KONANE;}
akonane						{return AKONANE;}
akon						{return AKONANE;}
mkonane						{return MKONANE;}
mkon						{return MKONANE;}
modern						{return MODERN;}
ancient						{return ANCIENT;}
toads						{return TOADS;}	/* Toads & Frogs */
subraction					{return SUBTRACTION;}
subtract					{return SUBTRACTION;}
sub						{return SUBTRACTION;}
trace						{return TRACE;}	/* enable trace output */
saltus						{return SALTUS;}
period						{return PERIOD;}
#.*						; /* Comment */
"[e]"						{return PROJECT;}
"[*]"						{return COOL_BY_STAR;}
"|"						{return BAR;}
"||"						{return BARR;}
"|||"						{return BARRR;}
"||||"						{return BARRRR;}
"|||||"						{return BARRRRR;}
"|0<"[0-9]+">"					{yylval.ival = atoi(yytext+3);
						 return BARZEROS;}
0"<"[0-9]+">"				        {yylval.ival = atoi(yytext+2);
						 return ZEROS;}
0|[1-9][0-9]*					{yylval.ival = atoi(yytext);
						 return NUM;}
"<("[1-9][0-9]*")>"				{yylval.ival = atoi(yytext+2);
						 return ONNUM;}
"<to "[1-9][0-9]*">"				{yylval.ival = atoi(yytext+4);
						 return ONNUM;}
[<>%_?\+\(\)\{\}\[\]\.\-\^\*v,\/=]		{return *yytext;}
"+"/"["						{return TINY;}
"-"/"["						{return MINY;}
[\n]						{return ENDOFSTRING;}
[ \t]						{}
v*['\1'$a-uw-zA-Z][a-zA-Z0-9]*			{yylval.lval = make_var (yytext);
						 return S;}
.						{return UNKNOWN;}
%%

int yywrap()
{
	return 1;
}

/* IF NOT USING GNU, INLUDE THE FOLLOWING
#define my_getc() (*(parser_input++))
#undef input
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):my_getc())==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
*/

#ifdef IBMPC
char *strdup (s)
	const char *s;
{
	char *t, *malloc();
	t = malloc (strlen (s) + 1);
	strcpy (t, s);
	return t;
}
#endif
