/* Copyright (C) David Wolfe, 1990.  All rights reserved. */

#include <stdlib.h>
#include <stdio.h>
#include "externs.h"
#include "rational.h"

#define p(x) Q_p(x)
#define q(x) Q_q(x)

int _Q_to_int (Q_type x) {		/* Cast Q_type into int, keeping low order bits */
	int i,y;
	for (i=y=0; i<INT_SIZE; i++, x>>=1)
		if (x & Q_BIT) y|=(1<<i);
	return y;
}

Q_type _int_to_Q (int x) {
	int i;
	Q_type y=Q_0;
	for (i=0; i<INT_SIZE; i++, x>>=1)
		if (x & 1) y |= (Q_BIT<<i);
	return y;
}

int Q_q (Q_type x) {
	int n = 1;
	while (!Q_is_int (x)) x <<= 1, n <<= 1;
	return n;
}	
/*	return (Q_is_int (x)) ? 1       OLD CODE
		: Q_to_int (Q_1 / (((x ^ (x-Q_BIT)) + Q_BIT) >> 1));
*/

int Q_p (Q_type x) {
	return Q_to_int (Q_is_int (x) ? x >> Q_SHIFT
			 : x / (((x ^ (x-Q_BIT)) + Q_BIT) >> 1));
}

Q_type Q_times (Q_type x, Q_type y) {
	return Q (p(x)*p(y), q(x)*q(y));
}

Q_type Q_divide (Q_type x, Q_type y) {
	if (p(y) == 0) myerror ("Q_divide: divide by zero");
	else if (y == Q_2) return x>>1;
	return Q (p(x)*q(y), q(x)*p(y));
}

Q_type Q_simplest_number (Q_type x, Q_type y) {
	int i;
	Q_type z;
	if (Q_ge (x, y)) {
		myerror ("Q_simplest_number: first argument exceeds second");
		return Q_0;
	}
	else if (Q_lt (x, Q_0)) return Q_gt (y, Q_0) ? Q_0
		: Q_negative (Q_simplest_number (Q_negative (y), Q_negative (x)));
	else if (Q_lt (Q_int(p(x)/q(x) + 1), y)) return Q_int(p(x)/q(x) + 1);
	for (i=1; (x>>i) != (y>>i); i++)
	  ;
	i--;
	z = ((x >> i) << i);
	if ((z | (Q_BIT<<i)) < y) z |= (Q_BIT << i);
	else while (z <= x && i >= 0) z |= (Q_BIT << --i);
	if (!(x < z && z < y)) myerror ("Q_simplest_number: rational fucked up");
	return z;
}

void Q_printf (Q_type x) {
	printf ("%d/%d\n", Q_p(x), Q_q(x));
	return;
}
