/* Copyright (C) David Wolfe, 1990.  All rights reserved. */

/* Does arithmetic on dyadic rationals. */

typedef long Q_type;
#define Q_SIZE 32
#define Q_SHIFT 20
#define Q_BIT ((Q_type) 1)

#define Q_0 ((Q_type) 0)
#define Q_1 (Q_BIT << Q_SHIFT)
#define Q_2 (Q_1 << 1)
#define Q_neg1 (- Q_1)
#define Q_infinity (((( Q_BIT << (Q_SIZE-2)) - Q_BIT) << 1) + Q_BIT)

/* Internal use only: don't use these */
#if (Q_SIZE > INT_SIZE) & !defined(IBMPC)
extern int		_Q_to_int(Q_type);
extern Q_type		_int_to_Q(int);
#define Q_to_int _Q_to_int
#define int_to_Q _int_to_Q
#else
#define Q_to_int(x) ((int) x)
#define int_to_Q(x) ((Q_type) x)
#endif

#define Q(a,b)		(int_to_Q(a) * (Q_1 / ((Q_type) b)))
#define Q_int(a)	(int_to_Q(a) << Q_SHIFT)
#define Q_plus(x,y)	((x)+(y))
#define Q_negative(x)	(-(x))
#define Q_minus(x,y)	((x)-(y))
#define Q_ge(x,y)	((x) >= (y))
#define Q_le(x,y)	((x) <= (y))
#define Q_eq(x,y)	((x) == (y))
#define Q_gt(x,y)	((x) > (y))
#define Q_lt(x,y)	((x) < (y))
#define Q_is_int(x)	((x & (Q_1 - Q_BIT)) == Q_0)
#define Q_exp(a)	(Q_BIT << (Q_SHIFT + a))
#define Q_sprint(s,x)	sprintf (s, "%d/%d", Q_p(x), Q_q(x))

extern int		Q_p (Q_type);
extern int		Q_q (Q_type);
extern Q_type		Q_times (Q_type, Q_type);
extern Q_type		Q_divide (Q_type, Q_type);
extern Q_type		Q_simplest_number (Q_type, Q_type);
extern void		Q_printf (Q_type);
