/* Copyright (C) David Wolfe, 1990.  All rights reserved. */

#include <stdlib.h>
#include <stdio.h>
#include "externs.h"
#include "list.h"
#include "hash.h"
#include "rational.h"
#include "gameops.h"
#include "output.h"
#include "subtraction.h"

game_type subtraction_table (list_type left_set, list_type right_set, int limit) {
  int n;
  game_type g;
  char s[5];
  char s1[80];
  char s2[80];
  var_type v;

  s[0] = 'g';
  if (period != NO_PERIOD)
    printf ("period = %d, saltus = %s\n",
	    period,
	    game_sprintn (s1, saltus, 10));
  printf ("LEFT: %s \t RIGHT: %s\n",
	  list_sprintn(s1, left_set, 80),
	  list_sprintn(s2, right_set, 80)); 
  for (n = 0 ; (n<=limit) | (limit==NO_LIMIT); n++) {
    g = subtraction (n, left_set, right_set);
    sprintf (s+1,"%d",n);
    v = make_var (s);
    set_var (v, g);
    if (n < period
	|| (period == NO_PERIOD)
	|| !eq (g, plus(saltus, subtraction (n - period,
					     left_set,
					     right_set))))
      printf ("%4s %s\n", s, game_sprintn (s2, g, 74));
/*  if (n % 20 == 0)
      sleep (1);
*/
  }
  list_free (left_set);
  list_free (right_set);
  return NO_GAME;
}

game_type subtraction (int n, list_type left_set, list_type right_set) {
  list_type lhash, left, right, l;
  game_type g;
  int i;


  lhash = list_combine (left_set, right_set);
  list_prepend (lhash, n);

  if (hash_test (SUBTRACTION_KEY, lhash)) {
    g = hash_get_last();
    list_free (lhash);
    return g;
  }    
  left = list_make();
  for (l = list_start (left_set); l != NIL; l = list_rest (l)) {
    i = n - list_pick (l);
    if (i >= 0)
      list_insert (left, subtraction (i, left_set, right_set));
  }
  right = list_make();
  for (l = list_start (right_set); l != NIL; l = list_rest (l)) {
    i = n - list_pick (l);
    if (i >= 0)
      list_insert (right, subtraction (i, left_set, right_set));
  }
  g = make (left, right);
  hash_put (SUBTRACTION_KEY, lhash, g);
  return g;
}
