/* Copyright (C) Jeff Erickson, 1993.  All rights reserved. */

/* ---------------------------------------------------------------------- *\
   Evaluates Toads & Frogs positions.
   For example, the position TT__FF evaluates to *
   (See _WW_, pp. 14-15, 65-66, 132-136, etc.)
\* ---------------------------------------------------------------------- */

/* ====================================================================== *\
   TOADS.C -- Play Toads and Frogs.  For rules, see _Winning Ways_, p.14.

   Copyright (C) Jeff Erickson, 1993.  All rights reserved.
   Permission is given to copy this file as part of David Wolfe's
   games program, provided nobody makes any money in the process.
\* ====================================================================== */

typedef enum {Wall=0, Toad, Frog, Blank, Unknown} T_Item;

typedef struct T
{
    int length;
    int components;	/* how many components? */
    int ttffbonus;	/* terminal toads/finished frogs bonus */
    T_Item *board;
} *T_type;

extern game_type	toads(void);
extern game_type	toads_position(T_type, int);
extern T_type		input_toads(void);
